#!/bin/sh
# $Id: unrar.SlackBuild,v 1.14 2017/07/16 14:22:17 root Exp root $
# Copyright 2004-2017  Eric Hameleers, Eindhoven, NL
# All rights reserved.
#
#   Permission to use, copy, modify, and distribute this software for
#   any purpose with or without fee is hereby granted, provided that
#   the above copyright notice and this permission notice appear in all
#   copies.
#
#   THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
#   WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
#   MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
#   IN NO EVENT SHALL THE AUTHORS AND COPYRIGHT HOLDERS AND THEIR
#   CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
#   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
#   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
#   USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
#   ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
#   OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
#   OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
#   SUCH DAMAGE.
# -----------------------------------------------------------------------------
#
# Slackware SlackBuild script 
# ===========================
# By:        Eric Hameleers <alien@slackware.com>
# For:       unrar
# Descr:     RAR archive extraction tool
# URL:       http://www.rarlab.com/rar_add.htm
# Needs:     
# Changelog:
# 3.4.3-1:   30/nov/2004 by Eric Hameleers
#            * Initial build.
# 3.6.2-1:   20/apr/2006 by Eric Hameleers <alien@slackware.com>
#            * Updates.
# 3.7.6-1:   30/May/2007 by Eric Hameleers <alien@slackware.com>
#            * Rebuilt for Slackware 11.0 with a revamped SlackBuild.
#              Added a man page (obtained from Debian).
# 3.7.8-1:   01/Feb/2008 by Eric Hameleers <alien@slackware.com>
#            * New release.
# 3.9.3-1:   22/may/2009 by Eric Hameleers <alien@slackware.com>
#            * New release.
# 3.9.6-1:   15/nov/2009 by Eric Hameleers <alien@slackware.com>
#            * New release.
# 3.9.10-1:  01/jun/2010 by Eric Hameleers <alien@slackware.com>
#            * New release.
# 3.9.10-2:  04/oct/2010 by Eric Hameleers <alien@slackware.com>
#            * Apply patch to fix CBR support in calibre.
# 4.0.7-1:   13/may/2011 by Eric Hameleers <alien@slackware.com>
#            * Update.
# 4.2.4-1:   01/jan/2013 by Eric Hameleers <alien@slackware.com>
#            * Update. Apply patch to allow the shared library
#              to be linked on 64-bit:
# 5.4.5-1:   31/jan/2017 by Eric Hameleers <alien@slackware.com>
#            * Update. Deferring to the way unrar is built in Arch Linux.
# 5.5.6-1:   16/jul/2017 by Eric Hameleers <alien@slackware.com>
#            * Update.
# 
# Run 'sh unrar.SlackBuild' to build a Slackware package.
# The package (.tgz) plus descriptive .txt file are created in /tmp .
# Install using 'installpkg'. 
#
# -----------------------------------------------------------------------------

# Set initial variables:

PRGNAM=unrar
VERSION=${VERSION:-5.5.6}
BUILD=${BUILD:-1}
TAG=${TAG:-alien}

DOCS="acknow.txt license.txt readme.txt"

# Where do we look for sources?
SRCDIR=$(cd $(dirname $0); pwd)

TMP=${TMP:-/tmp/build}
PKG=$TMP/package-$PRGNAM
OUTPUT=${OUTPUT:-/tmp}

SOURCE="$SRCDIR/${PRGNAM}src-${VERSION}.tar.gz"
SRCURL="http://www.rarlab.com/rar/${PRGNAM}src-${VERSION}.tar.gz"

##
## --- with a little luck, you won't have to edit below this point --- ##
##

# Automatically determine the architecture we're building on:
MARCH=$( uname -m )
if [ -z "$ARCH" ]; then
  case "$MARCH" in
    i?86)    export ARCH=i486 ;;
    armv7hl) export ARCH=$MARCH ;;
    arm*)    export ARCH=arm ;;
    # Unless $ARCH is already set, use uname -m for all other archs:
    *)       export ARCH=$MARCH ;;
  esac
fi

# Exit the script on errors:
set -e
trap 'echo "$0 FAILED at line $LINENO!" | tee $OUTPUT/error-${PRGNAM}.log' ERR
# Catch unitialized variables:
set -u
P1=${1:-1}

# Save old umask and set to 0022:
_UMASK_=$(umask)
umask 0022

case "$ARCH" in
  i?86)      SLKCFLAGS="-O2 -fPIC -march=${ARCH} -mtune=i686"
             SLKLDFLAGS=""; LIBDIRSUFFIX=""
             ;;
  x86_64)    SLKCFLAGS="-O2 -fPIC"
             SLKLDFLAGS="-L/usr/lib64"; LIBDIRSUFFIX="64"
             ;;
  armv7hl)   SLKCFLAGS="-O2 -march=armv7-a -mfpu=vfpv3-d16"
             SLKLDFLAGS=""; LIBDIRSUFFIX=""
             ;;
  *)         SLKCFLAGS="-O2 -fPIC"
             SLKLDFLAGS=""; LIBDIRSUFFIX=""
             ;;
esac

# Create working directories:
mkdir -p $TMP/tmp-$PRGNAM # location to build the source
rm -rf $TMP/tmp-$PRGNAM/* # remove the remnants of previous build
mkdir -p $PKG             # place for the package to be built
rm -rf $PKG/*             # erase old package's contents
mkdir -p $OUTPUT          # place for the package to be saved

# Source file availability:
if ! [ -f ${SOURCE} ]; then
  echo "Source '$(basename ${SOURCE})' not available yet..."
  # Check if the $SRCDIR is writable at all - if not, download to $OUTPUT
  [ -w "$SRCDIR" ] || SOURCE="$OUTPUT/$(basename $SOURCE)"
  if [ -f ${SOURCE} ]; then echo "Ah, found it!"; continue; fi
  if ! [ "x${SRCURL}" == "x" ]; then
    echo "Will download file to $(dirname $SOURCE)"
    wget -nv -T 20 -O "${SOURCE}" "${SRCURL}" || true
    if [ $? -ne 0 -o ! -s "${SOURCE}" ]; then
      echo "Downloading '$(basename ${SOURCE})' failed... aborting the build."
      mv -f "${SOURCE}" "${SOURCE}".FAIL
      exit 1
    fi
  else
    echo "File '$(basename ${SOURCE})' not available... aborting the build."
    exit 1
  fi
fi

if [ "$P1" == "--download" ]; then
  echo "Download complete."
  exit 0
fi

# --- PACKAGE BUILDING ---

echo "++"
echo "|| $PRGNAM-$VERSION"
echo "++"

cd $TMP/tmp-$PRGNAM
echo "Extracting the source archive(s) for $PRGNAM..."
tar -xvf ${SOURCE}
cd ${PRGNAM}
 
touch $OUTPUT/patch-$PRGNAM.log

# Brand the version into the soname:
cat $SRCDIR/patches/unrar.soname.patch | patch -p1 --verbose \
  2>&1 | tee -a $OUTPUT/patch-$PRGNAM.log

chown -R root:root .
chmod -R u+w,go+r-w,a+X-s .

echo Building ...
cp -a ../${PRGNAM} ../lib${PRGNAM}

make -C ../lib${PRGNAM} lib libversion=${VERSION} CXXFLAGS="$SLKCFLAGS" \
  2>&1 | tee $OUTPUT/make-${PRGNAM}.log
make -f makefile unrar lib CXXFLAGS="$SLKCFLAGS" \
  2>&1 | tee -a $OUTPUT/make-${PRGNAM}.log

# Manually install binaries:
install -D -m 755 unrar $PKG/usr/bin/unrar
install -D -m 755 ../lib${PRGNAM}/libunrar.so.$VERSION $PKG/usr/lib${LIBDIRSUFFIX}/libunrar.so.$VERSION
install -D -m 644 dll.hpp "$PKG/usr/include/unrar/dll.hpp"
( cd /usr/lib${LIBDIRSUFFIX}
  ln -s libunrar.so.$VERSION $PKG/usr/lib${LIBDIRSUFFIX}/libunrar.so
  ln -s libunrar.so.$VERSION $PKG/usr/lib${LIBDIRSUFFIX}/libunrar.so.$(echo $VERSION |cut -d'.' -f1)
)

# Add a man page:
mkdir -p $PKG/usr/man/man1
gzip -9cf $SRCDIR/${PRGNAM}.1 > $PKG/usr/man/man1/${PRGNAM}.1.gz

# Add documentation:
mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
cp -a $DOCS $PKG/usr/doc/$PRGNAM-$VERSION || true
cat $SRCDIR/$(basename $0) > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
find $PKG/usr/doc -type f -exec chmod 0644 {} \; || true

# Strip binaries:
find $PKG | xargs file | grep -e "executable" -e "shared object" \
  | grep ELF | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null

# Add a package description:
mkdir -p $PKG/install
cat $SRCDIR/slack-desc > $PKG/install/slack-desc

# Build the package:
cd $PKG
makepkg --linkadd y --chown n $OUTPUT/${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.tgz 2>&1 | tee $OUTPUT/makepkg-${PRGNAM}.log
cd $OUTPUT
md5sum ${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.tgz > ${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.tgz.md5
cd -
cat $PKG/install/slack-desc | grep "^${PRGNAM}" > $OUTPUT/${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.txt

# Restore the original umask:
umask ${_UMASK_}

